Index: main/plugin-admin/src/org/ametys/runtime/plugins/admin/datasource/GetDataSourcesAction.java
===================================================================
--- main/plugin-admin/src/org/ametys/runtime/plugins/admin/datasource/GetDataSourcesAction.java	(revision 0)
+++ main/plugin-admin/src/org/ametys/runtime/plugins/admin/datasource/GetDataSourcesAction.java	(revision 0)
@@ -0,0 +1,183 @@
+/*
+ *  Copyright 2015 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.runtime.plugins.admin.datasource;
+
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.apache.avalon.framework.parameters.Parameters;
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.cocoon.acting.ServiceableAction;
+import org.apache.cocoon.environment.ObjectModelHelper;
+import org.apache.cocoon.environment.Redirector;
+import org.apache.cocoon.environment.Request;
+import org.apache.cocoon.environment.SourceResolver;
+import org.apache.commons.lang3.StringUtils;
+
+import org.ametys.core.cocoon.JSonReader;
+import org.ametys.core.datasource.ldap.LDAPDataSourceManager;
+import org.ametys.core.datasource.ldap.LDAPDataSourceManager.LDAPDataSourceDescriptor;
+import org.ametys.core.datasource.sql.SQLDataSourceManager;
+
+/**
+ * Retrieve the datasources and format them in JSON
+ */
+public class GetDataSourcesAction extends ServiceableAction
+{
+    /** The manager handling the SQL data sources */
+    private SQLDataSourceManager _sqlDataSourceManager; 
+    
+    /** The manager handling the LDAP data sources */
+    private LDAPDataSourceManager _ldapDataSourceManager; 
+    
+    @Override
+    public void service(ServiceManager serviceManager) throws ServiceException
+    {
+        _sqlDataSourceManager = (SQLDataSourceManager) serviceManager.lookup(SQLDataSourceManager.ROLE);
+        _ldapDataSourceManager = (LDAPDataSourceManager) serviceManager.lookup(LDAPDataSourceManager.ROLE);
+    }
+    
+    @Override
+    public Map act(Redirector redirector, SourceResolver resolver, Map objectModel, String source, Parameters parameters) throws Exception
+    {
+        Map<String, Object> result = new HashMap<> ();
+
+        Request request = ObjectModelHelper.getRequest(objectModel);
+        String includePrivateAsString = request.getParameter("includePrivate"); 
+        String includeDefaultAsString = request.getParameter("includeDefault"); 
+        String type = request.getParameter("type");
+        
+        boolean includePrivate = includePrivateAsString == null || includePrivateAsString.equals("true"); // Default value is true
+        boolean includeDefault = includeDefaultAsString != null && includeDefaultAsString.equals("true"); // Default value is false
+        
+        List<Map<String, Object>> dataSources = new ArrayList<>();
+
+        if (StringUtils.isEmpty(type) || type.equals("SQL"))
+        {
+            dataSources.addAll(_getSQLDataSources (includePrivate, includeDefault));
+        }
+        
+        if (StringUtils.isEmpty(type) || type.equals("LDAP"))
+        {
+            dataSources.addAll(_getLDAPDataSources (includePrivate));
+        }
+        
+        result.put("datasources", dataSources);
+        
+        request.setAttribute(JSonReader.OBJECT_TO_READ, result);
+        return EMPTY_MAP;
+    }
+    
+    /**
+     * Get all sql data sources
+     * @param includePrivate true to include the private data sources
+     * @param includeDefault true to include the default data source 
+     * @return the sql data sources
+     * @throws Exception if an exception occurs while retrieving the SQL data sources
+     */
+    private List<Map<String, Object>> _getSQLDataSources (boolean includePrivate, boolean includeDefault) throws Exception
+    {
+        List<Map<String, Object>> dataSources = new ArrayList<>();
+        
+        Map<String, Map<String, Object>> dataSourcesDescriptions = _sqlDataSourceManager.getSQLDataSourcesDescriptions();
+        String defaultDataSourceId = _sqlDataSourceManager.getDefaultDataSourceId();
+        
+        for (String id : dataSourcesDescriptions.keySet())
+        {
+            Map<String, Object> dataSource = new HashMap<>();
+            Map<String, Object> dataSourceDescriptor = dataSourcesDescriptions.get(id);
+            if (id.equals(defaultDataSourceId))
+            {
+                if (includeDefault)
+                {
+                    dataSource.putAll(dataSourceDescriptor);
+
+                    dataSource.put("id", defaultDataSourceId);
+                    dataSource.put("name", _sqlDataSourceManager.getDefaultDataSourceName());
+                    dataSource.put("description", _sqlDataSourceManager.getDefaultDataSourceDescription());
+                    dataSource.put("type", "SQL");
+                    dataSource.put("inUse", _sqlDataSourceManager.isInUse(defaultDataSourceId));
+                    
+                    dataSources.add(dataSource);
+                }
+            }
+            else
+            {
+                dataSource.put("type", "SQL");
+                dataSource.put("private", false); // Default value
+                dataSource.put("inUse", _sqlDataSourceManager.isInUse(id));
+                
+                dataSource.putAll(dataSourceDescriptor);
+                dataSource.put("id", id);
+                
+                if (!((Boolean) dataSourceDescriptor.get("private")) || includePrivate)
+                {
+                    dataSources.add(dataSource);
+                }
+            }
+        }
+        
+        return dataSources;
+    }
+    
+    /**
+     * Get all ldap data sources
+     * @param includePrivate true to include the private data sources
+     * @return the ldap data sources
+     * @throws Exception if an exception occurs while retrieving the SQL data sources
+     */
+    private List<Map<String, Object>> _getLDAPDataSources (boolean includePrivate) throws Exception
+    {
+        List<Map<String, Object>> dataSources = new ArrayList<>();
+        
+        Map<String, LDAPDataSourceDescriptor> dataSourcesDescriptions = _ldapDataSourceManager.getLDAPDataSourcesDescriptions();
+        
+        for (String id : dataSourcesDescriptions.keySet())
+        {
+            Map<String, Object> dataSource = new HashMap<>();
+            LDAPDataSourceDescriptor dataSourceDescriptor = dataSourcesDescriptions.get(id);
+         
+            dataSource.put("type", "LDAP");
+            dataSource.put("private", false); // Default value
+            dataSource.put("inUse", _ldapDataSourceManager.isInUse(id));
+            
+            dataSource.put("id", id);
+            dataSource.put("name", dataSourceDescriptor.getName());
+            dataSource.put("description", dataSourceDescriptor.getDescription());
+            dataSource.put("baseURL", dataSourceDescriptor.getBaseURL());
+            dataSource.put("useSSL", dataSourceDescriptor.isUsingSSL());
+            dataSource.put("baseDN", dataSourceDescriptor.getBaseDN());
+            dataSource.put("aliasDereferencing", dataSourceDescriptor.getAliasDereferencing());
+            dataSource.put("followReferrals", dataSourceDescriptor.isFollowingReferrals());
+            dataSource.put("authenticationMethod", dataSourceDescriptor.getAuthenticationMethod());
+            dataSource.put("adminDN", dataSourceDescriptor.getAdminDN());
+            dataSource.put("adminPassword", dataSourceDescriptor.getAdminPassword());
+            dataSource.put("private", dataSourceDescriptor.isPrivate());
+            dataSource.put("type", "LDAP");
+            dataSource.put("id", id);
+            
+            if (!dataSourceDescriptor.isPrivate() || includePrivate)
+            {
+                dataSources.add(dataSource);
+            }
+        }
+        
+        return dataSources;
+    }
+}
Index: main/plugin-core/src/org/ametys/core/datasource/AbstractMyBatisDAO.java
===================================================================
--- main/plugin-core/src/org/ametys/core/datasource/AbstractMyBatisDAO.java	(revision 38980)
+++ main/plugin-core/src/org/ametys/core/datasource/AbstractMyBatisDAO.java	(working copy)
@@ -44,6 +44,8 @@
 import org.apache.ibatis.transaction.TransactionFactory;
 import org.apache.ibatis.transaction.jdbc.JdbcTransactionFactory;
 
+import org.ametys.core.datasource.sql.SQLDataSourceManager;
+import org.ametys.runtime.config.Config;
 import org.ametys.runtime.plugin.PluginsManager;
 import org.ametys.runtime.plugin.component.AbstractLogEnabled;
 import org.ametys.runtime.plugin.component.PluginAware;
@@ -55,10 +57,10 @@
 public abstract class AbstractMyBatisDAO extends AbstractLogEnabled implements Contextualizable, Serviceable, PluginAware, Configurable, Initializable
 {
     private SqlSessionFactory _sessionFactory;
-    private DataSourceExtensionPoint _dsExtPoint;
+    private SQLDataSourceManager _sqlDataSourceManager;
     private String _contextPath;
     private String _pluginName;
-    private String _poolName;
+    private String _poolConfigParam;
     private Set<SqlMap> _sqlMaps;
     
     public void contextualize(org.apache.avalon.framework.context.Context context) throws ContextException
@@ -70,7 +72,7 @@
     @Override
     public void service(ServiceManager manager) throws ServiceException
     {
-        _dsExtPoint = (DataSourceExtensionPoint) manager.lookup(DataSourceExtensionPoint.ROLE);
+        _sqlDataSourceManager = (SQLDataSourceManager) manager.lookup(SQLDataSourceManager.ROLE);
     }
     
     public void setPluginInfo(String pluginName, String featureName)
@@ -80,8 +82,7 @@
     
     public void configure(Configuration configuration) throws ConfigurationException
     {
-        _poolName = configuration.getChild("datasource", true).getValue(ConnectionHelper.CORE_POOL_NAME);
-        
+        _poolConfigParam = configuration.getChild("datasource", true).getValue(ConnectionHelper.CORE_POOL_CONFIG_PARAM);
         _sqlMaps = new HashSet<>();
         Configuration[] sqlMaps = configuration.getChildren("sqlMap");
         for (Configuration sqlMapConf : sqlMaps)
@@ -117,17 +118,18 @@
     
     public void initialize() throws Exception
     {
-        DataSource dataSource = _dsExtPoint.getExtension(_poolName);
+        String dataSourceId = Config.getInstance().getValueAsString(_poolConfigParam);
+        DataSource dataSource = _sqlDataSourceManager.getSQLDataSource(dataSourceId);
         
         if (dataSource == null)
         {
-            throw new ConfigurationException("Invalid pool name: " + _poolName);
+            throw new ConfigurationException("Invalid pool configuration parameter: " + _poolConfigParam);
         }
         
         SqlSessionFactoryBuilder sessionFactoryBuilder = new SqlSessionFactoryBuilder();
         
         TransactionFactory transactionFactory = new JdbcTransactionFactory();
-        Environment env = new Environment(_poolName, transactionFactory, dataSource);
+        Environment env = new Environment(_poolConfigParam, transactionFactory, dataSource);
         
         org.apache.ibatis.session.Configuration config = new org.apache.ibatis.session.Configuration(env);
         config.setCacheEnabled(true);
@@ -170,7 +172,7 @@
                 
                 if (getLogger().isInfoEnabled())
                 {
-                    getLogger().info("Initialized mybatis mapper at location '{}' for pool '{}'", mapperLocation, _poolName);
+                    getLogger().info("Initialized mybatis mapper at location '{}' for pool '{}'", mapperLocation, _poolConfigParam);
                 }
 
                 XMLMapperBuilder mapperParser = new XMLMapperBuilder(mapperStream, config, mapperLocation, config.getSqlFragments());
Index: main/plugin-core/src/org/ametys/core/datasource/ConnectionHelper.java
===================================================================
--- main/plugin-core/src/org/ametys/core/datasource/ConnectionHelper.java	(revision 38980)
+++ main/plugin-core/src/org/ametys/core/datasource/ConnectionHelper.java	(working copy)
@@ -22,22 +22,30 @@
 
 import javax.sql.DataSource;
 
+import org.apache.avalon.framework.component.Component;
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.avalon.framework.service.Serviceable;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
 
+import org.ametys.core.datasource.sql.SQLDataSourceManager;
+
 /**
- * Helper class to retrieve java.sql.Connection from pools
+ * Helper component used to retrieve java.sql.Connection from pools
  */
-public final class ConnectionHelper
+public final class ConnectionHelper implements Component, Serviceable
 {
-    /**
-     * Constant for core Connection pool name
-     */
-    public static final String CORE_POOL_NAME = "runtime.datasource.core.jdbc.pool";
+    /** The id of the configuration parameter corresponding to the core connection pool */
+    public static final String CORE_POOL_CONFIG_PARAM = "runtime.datasource.core.jdbc.pool";
     
-    /**
-     * Enumeration for database type.<br>
-     */
+    /** Logger for traces */
+    private static Logger _logger = LoggerFactory.getLogger(ConnectionHelper.class.getName());
+    
+    /** The manager for SQL data source */
+    private static SQLDataSourceManager _sqlDataSourceManager;
+    
+    /** Enumeration for database type.&lt;br&gt; */
     public enum DatabaseType
     {
         /** Database type is unknown */
@@ -59,51 +67,33 @@
         DATABASE_HSQLDB
     }
     
-    // Logger for traces
-    private static Logger _logger = LoggerFactory.getLogger(ConnectionHelper.class.getName());
-
-    private static DataSourceExtensionPoint _extensionPoint;
-    
-    private ConnectionHelper()
+    @Override
+    public void service(ServiceManager serviceManager) throws ServiceException
     {
-        // empty constructor
+        _sqlDataSourceManager = (SQLDataSourceManager) serviceManager.lookup(SQLDataSourceManager.ROLE); 
     }
-    
-    /**
-     * Initializes the Datasources holding the actual Connections
-     * @param extensionPoint the application DataSourceExtensionPoint 
-     */
-    public static void setExtensionPoint(DataSourceExtensionPoint extensionPoint)
-    {
-        _extensionPoint = extensionPoint;
-    }
-    
+
     /**
      * Returns a Connection from the pool.
-     * @param poolName the name of the Avalon connection pool
+     * @param id the id of the data source configuration parameter
      * @return a java.sql.Connection to query a SQL database
      */
-    public static Connection getConnection(String poolName)
+    public static Connection getConnection(String id)
     {
-        if (_extensionPoint == null)
-        {
-            throw new IllegalStateException("ComponentSelector has not been properly set up. The method setSelector(selector) must be called before getting any Connection.");
-        }
-
         DataSource dataSource;
-        Connection conn = null;
-
+        Connection connection = null;
+        
         try
         {
-            dataSource =  _extensionPoint.getExtension(poolName);
-            conn = dataSource.getConnection();
+            dataSource =  _sqlDataSourceManager.getSQLDataSource(id);
+            connection = dataSource.getConnection();
         }
         catch (SQLException e)
         {
-            throw new RuntimeException("Unable to get Connection from pool " + poolName, e);
+            throw new RuntimeException("Unable to get Connection from pool " + id, e);
         }
 
-        return conn;
+        return connection;
     }
     
     /**
